﻿namespace EonaCat.WebSockets.Extensions
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    public class AgreedValuableParameter<T> : AgreedExtensionParameter
    {
        public AgreedValuableParameter(string name, T @value)
            : base(name)
        {
            this.Value = @value;
        }

        public override ExtensionParameterType ParameterType
        {
            get
            {
                return ExtensionParameterType.Valuable;
            }
        }

        public T Value { get; private set; }

        public override string ToString()
        {
            return string.Format("{0}={1}", this.Name, this.Value);
        }
    }
}
